Imports System.EnterpriseServices

'indicate the COM+ application name
<Assembly: ApplicationName("myComApp")> 

'indicate the key pair used to generate the strong name for the assembly
<Assembly: System.Reflection.AssemblyKeyFile("keyPair.snk")> 

<Transaction(TransactionOption.Required), _
  ObjectPoolingAttribute(MinPoolSize:=5, MaxPoolSize:=10), _
  EventTrackingEnabledAttribute(True)> _
Public Class myPooledObject

  'purpose:   provide pooled component example

  'class-level scope
  Inherits ServicedComponent

  <AutoComplete()> _
  Public Function doTask() As Boolean

    'purpose:   simulate a function

    Return True

  End Function

  Public Overrides Function CanBePooled() As Boolean

    'purpose:   called by COM+ after Deactivate
    '           used to decide if the object can be returned to the 
    '           queue or should be discarded

    Return True

  End Function

  Public Overrides Sub Activate()

    'purpose:   called when an object is handed out to a client and
    '           removed from the pool

  End Sub

  Public Overrides Sub Deactivate()

    'purpose:   called before placing back in the pool on deactivation

  End Sub

End Class


