Imports System.EnterpriseServices

<Assembly: ApplicationName("myApp")> 

'indicate the key pair used to generate the strong name for the assembly
<Assembly: System.Reflection.AssemblyKeyFile("sharedProp.snk")> 

Public Class classSet

  'purpose: sets a value in the shared propery group

  Inherits ServicedComponent

  <AutoComplete()> _
  Public Sub setProp(ByVal propVal As String)

    'local scope
    Dim spGroupMgr As SharedPropertyGroupManager
    Dim spGroup As SharedPropertyGroup
    Dim sharedProp As SharedProperty

    'create a property group manager object
    spGroupMgr = New SharedPropertyGroupManager()

    'create a shared property group
    spGroup = spGroupMgr.CreatePropertyGroup( _
        name:="spGroup", dwIsoMode:=PropertyLockMode.SetGet, _
        dwRelMode:=PropertyReleaseMode.Standard, fExist:=False)

    'create a property
    sharedProp = spGroup.CreateProperty(name:="spProp", fExists:=True)

    'set the property value to the passed string value
    sharedProp.Value = propVal

  End Sub

End Class

Public Class classGet

  'purpose: retrieves a value in the shared propert group

  Inherits ServicedComponent

  <AutoComplete()> _
  Public Function getProp() As String

    'local scope
    Dim spGroupMgr As SharedPropertyGroupManager
    Dim spGroup As SharedPropertyGroup
    Dim sharedProp As SharedProperty

    'create a property group manager object
    spGroupMgr = New SharedPropertyGroupManager()

    'find our shared property group
    spGroup = spGroupMgr.CreatePropertyGroup( _
        name:="spGroup", dwIsoMode:=PropertyLockMode.SetGet, _
        dwRelMode:=PropertyReleaseMode.Standard, fExist:=True)

    'get our property
    sharedProp = spGroup.Property(name:="spProp")

    'return the property value
    getProp = sharedProp.Value

  End Function

End Class

Module Module1

  Sub Main()

    'local scope

    'create the class that sets the shared prop
    Dim mySet As New classSet()

    'set the shared property
    mySet.setProp(propVal:="This is a shared property!")

    'create a class that reads the property
    Dim myGet As New classGet()

    'get the property and write out to the console
    Console.WriteLine(myGet.getProp())

    'wait
    Do While Console.ReadLine <> "s" : Loop

  End Sub

End Module
