Imports System.EnterpriseServices
Imports System.Data.OleDb

'indicate the COM+ application to use
<Assembly: ApplicationName("trx")> 

'indicate the key pair used to generate the strong name for the assembly
<Assembly: System.Reflection.AssemblyKeyFile("trx.snk")> 

'create interface for trxWrite
Public Interface IWrite
    Sub writeTrx(ByVal strText As String)
End Interface

'create interface for trxManage
Public Interface IManage
    Sub manageTrx()
End Interface

'set the transaction attribute
<Transaction(TransactionOption.Required)> _
Public Class trxWrite

  'indicate serviced component
  Inherits ServicedComponent

  'use the IWrite interface
  Implements IWrite

  'indicate that the transaction should setComplete on success
  '   and setAbort upon an exception
  <AutoComplete(True)> _
  Public Sub writeTrx(ByVal strText As String) Implements IWrite.writeTrx

    'purpose: execute a database insert and auto commit

    'local scope
    Dim myConn As OleDbConnection
    Dim myCommand As New OleDbCommand()
    Dim sql As String

    'create a database connection
    myConn = New OleDbConnection(connectionString:= _
        "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\trxDb.mdb")

    'set an insert statement
    sql = "insert into trxTest (name) values('" & strText & "')"

    'set command text
    myCommand.CommandText = sql

    'set connection property of command object
    myCommand.Connection = myConn

    'open the database connection
    myConn.Open()

    'execute the sql statement
    myCommand.ExecuteNonQuery()

    'close the db connection
    myCommand.Connection.Close()

  End Sub

End Class

'indicate that the class must create a new transaction
<Transaction(TransactionOption.RequiresNew)> _
Public Class trxManage

  'purpose: manage a 2 part transaction

  'indicate serviced component
  Inherits ServicedComponent

  'use the IManage interface
  Implements IManage

  Public Sub manageTrx() Implements IManage.manageTrx

    'local scope
    Dim myTrxEvent As New trxWrite()

    'indicate that com+ can deactivate the object upon return
    ContextUtil.DeactivateOnReturn = True

    'call the logging transaction
    myTrxEvent.writeTrx("Test Event")

    'abort the transaction
    ContextUtil.MyTransactionVote = TransactionVote.Abort

  End Sub

End Class

Module Module1

  Sub Main()

    'purpose: act as a client to the trx manager class

    'local scope
    Dim trxManage As New trxExample.trxManage()

    'call the transaction manage method
    trxManage.manageTrx()

  End Sub

End Module
