Imports System.EnterpriseServices

'indicate the COM+ application to use
<Assembly: ApplicationName("mylcEventApp")> 

'set the application to a library package
<Assembly: ApplicationActivation(ActivationOption.Library)> 

'indicate the key pair used to generate the strong name for the assembly
<Assembly: System.Reflection.AssemblyKeyFile("lcEventSNK.snk")> 

Public Interface myEventInterface

    'purpose: interface communication object between event 
    '   publisher(s) and event subscriber(s)

    Sub someEvent(ByVal somData As String)

End Interface

<EventClass()> _
Public Class myEventClass

    'purpose: create an actual event class to be used '
    '   to pass events to subscribers

    'mark as serviced component
    Inherits ServicedComponent

    Implements myEventInterface

    Public Sub someEvent(ByVal someData As String) _
        Implements lceCode.myEventInterface.someEvent

        'purpose: pass notification from publisher to subscriber

    End Sub

End Class

Public Class mySubscriberClass

    'purpose: subscribe to the event
    '   this event sink will get notice when event is fired
    '   by publisher

    'mark as serviced component
    Inherits ServicedComponent

    'implement event class
    Implements myEventInterface

    'implement event 
    <AutoComplete()> _
    Public Sub someEvent(ByVal someData As String) _
        Implements lceCode.myEventInterface.someEvent

        'purpose: receive notification that a publisher has sent 
        '   and event. note, this routine receives notification 
        '   via the myEventInterface interface

        'record the event's data
        MsgBox(someData)
        EventLog.WriteEntry(source:="messageManager", _
            Message:=someData, _
            type:=EventLogEntryType.Information)

    End Sub

End Class

Module Module1

    'purpose: create an event publisher

    Sub Main()

        'purpose: act as the publisher and fire the event class

        'local scope
        Dim fireEvent As myEventInterface

        'convert interface to an instance of the event class
        fireEvent = CType(New myEventClass(), myEventInterface)

        'fire the event
        fireEvent.someEvent("Event data ...")

    End Sub

End Module
